package id.durianpay.dpay_flutter;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.os.Build;
import android.util.Log;

import androidx.annotation.RequiresApi;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.Map;

import io.flutter.plugin.common.MethodChannel.Result;

import id.durianpay.android.Durianpay;
import id.durianpay.android.Interfaces.CheckoutResultListener;
import id.durianpay.android.model.DCheckoutOptions;

@RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
public class DurianpayCheckout implements CheckoutResultListener {
    private Activity activity;
    private Result result;

    public DurianpayCheckout(Activity act) {
        activity = act;
    }

    public void openCheckout(final Map<String, Object> checkoutoptions, final Result result) {
        this.result = result;
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Log.d("into the class", "DurianpayCheckout");
                final JSONObject options = new JSONObject(checkoutoptions);

                final DCheckoutOptions checkoutOptions = new DCheckoutOptions();
                try {
                    if (options.get("environment") != JSONObject.NULL) checkoutOptions.setEnvironment(String.valueOf(options.get("environment")));
                    if (options.get("locale") != JSONObject.NULL) checkoutOptions.setLocale(String.valueOf(options.get("locale")));
                    if (options.get("siteName") != JSONObject.NULL) checkoutOptions.setSiteName(String.valueOf(options.get("siteName")));
                    if (options.get("customerId") != JSONObject.NULL) checkoutOptions.setCustomerId(String.valueOf(options.get("customerId")));
                    if (options.get("customerGivenName") != JSONObject.NULL) checkoutOptions.setCustomerGivenName(String.valueOf(options.get("customerGivenName")));
                    if (options.get("customerEmail") != JSONObject.NULL) checkoutOptions.setCustomerEmail(String.valueOf(options.get("customerEmail")));
                    if (options.get("orderId") != JSONObject.NULL) checkoutOptions.setOrderId(String.valueOf(options.get("orderId")));
                    if (options.get("accessToken") != JSONObject.NULL) checkoutOptions.setAccessToken(String.valueOf(options.get("accessToken")));
                    if (options.get("payment_type") != JSONObject.NULL) checkoutOptions.setPaymentType(String.valueOf(options.get("payment_type")));
                    if (options.get("amount") != JSONObject.NULL) checkoutOptions.setAmount(String.valueOf(options.get("amount")));

                    Durianpay.getInstance(activity).checkout(checkoutOptions, DurianpayCheckout.this);
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
        });
    }

    @SuppressLint("LongLogTag")
    @Override
    public void onSuccess(final String s) {
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Log.d("from android-sdk to flutter android", s);
                result.success(s);
            }
        });
    }

    @SuppressLint("LongLogTag")
    @Override
    public void onFailure(final String s) {
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Log.d("from android-sdk to flutter android", s);
                result.success(s);
            }
        });
    }

    @SuppressLint("LongLogTag")
    @Override
    public void onClose(final String s) {
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Log.d("from android-sdk to flutter android", s);
                result.success(s);
            }
        });
    }
}
